"""
Contains abstract class for a mirrored project
"""

from abc import ABC
import re

import requests

from shared import CSC_MIRROR


class Project(ABC):
	"""Abstract class for a mirrored project"""

	@staticmethod
	def check(data, project, current_time):
		"""Check if project packages are up-to-date"""
		csc_url = CSC_MIRROR + data[project]["csc"] + data[project]["file"]
		upstream_url = data[project]["upstream"] + data[project]["file"]
		CSC = requests.get(csc_url).text
		upstream = requests.get(upstream_url).text
		bad_re = '[a-zA-Z \-\n]+'
		if re.search(bad_re, CSC):
			print(re.search(bad_re, CSC).group())
			CSC = re.sub(bad_re, '', CSC)
			upstream = re.sub(bad_re, '', upstream)
		return int(upstream) - int(CSC)
